const Yup = require("yup");

const schema = Yup.string().transform(value => {
    const upper = value.toUpperCase();
    const lower = value.toLowerCase();
    if (value === upper) value = value.toLowerCase();
    else if (value === lower)  value = value.toUpperCase();
    return value;
})

const values = ['borris', 'JOHN', 'Mary'];
const transformed = values.map(value => schema.cast(value));

values.forEach((value, i) => console.log(`${value} => ${transformed[i]}`));
